Skip to content
Snippets Groups Projects
  • Xin Ren's avatar
    6ab973ec
    [SPARK-15542][SPARKR] Make error message clear for script './R/install-dev.sh'... · 6ab973ec
    Xin Ren authored
    [SPARK-15542][SPARKR] Make error message clear for script './R/install-dev.sh' when R is missing on Mac
    
    https://issues.apache.org/jira/browse/SPARK-15542
    
    ## What changes were proposed in this pull request?
    
    When running`./R/install-dev.sh` in **Mac OS EI Captain** environment, I got
    ```
    mbp185-xr:spark xin$ ./R/install-dev.sh
    usage: dirname path
    ```
    This message is very confusing to me, and then I found R is not properly configured on my Mac when this script is using `$(which R)` to get R home.
    
    I tried similar situation on CentOS with R missing, and it's giving me very clear error message while MacOS is not.
    on CentOS:
    ```
    [rootip-xxx-31-9-xx spark]# which R
    /usr/bin/which: no R in (/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:/usr/lib/jvm/java-1.7.0-openjdk.x86_64/bin:/root/bin)
    ```
    but on Mac, if not found then nothing returned and this is causing the confusing message for R build failure and running R/install-dev.sh:
    ```
    mbp185-xr:spark xin$ which R
    mbp185-xr:spark xin$
    ```
    
    Here I just added a clear message for this miss configuration for R when running `R/install-dev.sh`.
    ```
    mbp185-xr:spark xin$ ./R/install-dev.sh
    Cannot find R home by running 'which R', please make sure R is properly installed.
    ```
    
    ## How was this patch tested?
    Manually tested on local machine.
    
    Author: Xin Ren <iamshrek@126.com>
    
    Closes #13308 from keypointt/SPARK-15542.
    6ab973ec
    History
    [SPARK-15542][SPARKR] Make error message clear for script './R/install-dev.sh'...
    Xin Ren authored
    [SPARK-15542][SPARKR] Make error message clear for script './R/install-dev.sh' when R is missing on Mac
    
    https://issues.apache.org/jira/browse/SPARK-15542
    
    ## What changes were proposed in this pull request?
    
    When running`./R/install-dev.sh` in **Mac OS EI Captain** environment, I got
    ```
    mbp185-xr:spark xin$ ./R/install-dev.sh
    usage: dirname path
    ```
    This message is very confusing to me, and then I found R is not properly configured on my Mac when this script is using `$(which R)` to get R home.
    
    I tried similar situation on CentOS with R missing, and it's giving me very clear error message while MacOS is not.
    on CentOS:
    ```
    [rootip-xxx-31-9-xx spark]# which R
    /usr/bin/which: no R in (/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:/usr/lib/jvm/java-1.7.0-openjdk.x86_64/bin:/root/bin)
    ```
    but on Mac, if not found then nothing returned and this is causing the confusing message for R build failure and running R/install-dev.sh:
    ```
    mbp185-xr:spark xin$ which R
    mbp185-xr:spark xin$
    ```
    
    Here I just added a clear message for this miss configuration for R when running `R/install-dev.sh`.
    ```
    mbp185-xr:spark xin$ ./R/install-dev.sh
    Cannot find R home by running 'which R', please make sure R is properly installed.
    ```
    
    ## How was this patch tested?
    Manually tested on local machine.
    
    Author: Xin Ren <iamshrek@126.com>
    
    Closes #13308 from keypointt/SPARK-15542.
install-dev.sh 2.07 KiB
#!/bin/bash

#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# This scripts packages the SparkR source files (R and C files) and
# creates a package that can be loaded in R. The package is by default installed to
# $FWDIR/lib and the package can be loaded by using the following command in R:
#
#   library(SparkR, lib.loc="$FWDIR/lib")
#
# NOTE(shivaram): Right now we use $SPARK_HOME/R/lib to be the installation directory
# to load the SparkR package on the worker nodes.

set -o pipefail
set -e

FWDIR="$(cd `dirname $0`; pwd)"
LIB_DIR="$FWDIR/lib"

mkdir -p $LIB_DIR

pushd $FWDIR > /dev/null
if [ ! -z "$R_HOME" ]
  then
    R_SCRIPT_PATH="$R_HOME/bin"
  else
    # if system wide R_HOME is not found, then exit
    if [ ! `command -v R` ]; then
      echo "Cannot find 'R_HOME'. Please specify 'R_HOME' or make sure R is properly installed."
      exit 1
    fi
    R_SCRIPT_PATH="$(dirname $(which R))"
fi
echo "USING R_HOME = $R_HOME"

# Generate Rd files if devtools is installed
"$R_SCRIPT_PATH/"Rscript -e ' if("devtools" %in% rownames(installed.packages())) { library(devtools); devtools::document(pkg="./pkg", roclets=c("rd")) }'

# Install SparkR to $LIB_DIR
"$R_SCRIPT_PATH/"R CMD INSTALL --library=$LIB_DIR $FWDIR/pkg/

# Zip the SparkR package so that it can be distributed to worker nodes on YARN
cd $LIB_DIR
jar cfM "$LIB_DIR/sparkr.zip" SparkR

popd > /dev/null